Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents picGraph As System.Windows.Forms.PictureBox
    Friend WithEvents btnGraph As System.Windows.Forms.Button
    Friend WithEvents tmrUpdateClock As System.Windows.Forms.Timer
    Friend WithEvents lblTime As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.picGraph = New System.Windows.Forms.PictureBox
        Me.btnGraph = New System.Windows.Forms.Button
        Me.tmrUpdateClock = New System.Windows.Forms.Timer(Me.components)
        Me.lblTime = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'picGraph
        '
        Me.picGraph.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.picGraph.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picGraph.Location = New System.Drawing.Point(0, 40)
        Me.picGraph.Name = "picGraph"
        Me.picGraph.Size = New System.Drawing.Size(291, 232)
        Me.picGraph.TabIndex = 0
        Me.picGraph.TabStop = False
        '
        'btnGraph
        '
        Me.btnGraph.Location = New System.Drawing.Point(8, 8)
        Me.btnGraph.Name = "btnGraph"
        Me.btnGraph.Size = New System.Drawing.Size(48, 24)
        Me.btnGraph.TabIndex = 1
        Me.btnGraph.Text = "Graph"
        '
        'tmrUpdateClock
        '
        Me.tmrUpdateClock.Enabled = True
        Me.tmrUpdateClock.Interval = 250
        '
        'lblTime
        '
        Me.lblTime.Location = New System.Drawing.Point(80, 8)
        Me.lblTime.Name = "lblTime"
        Me.lblTime.Size = New System.Drawing.Size(80, 16)
        Me.lblTime.TabIndex = 2
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.Add(Me.lblTime)
        Me.Controls.Add(Me.btnGraph)
        Me.Controls.Add(Me.picGraph)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_Ymid As Integer
    Private m_Y As Integer
    Private Const GRID_STEP As Integer = 40

    ' Get ready.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_Ymid = picGraph.ClientSize.Height \ 2
        m_Y = m_Ymid

        ' Make the Bitmap and Graphics objects.
        Dim wid As Integer = picGraph.ClientSize.Width
        Dim hgt As Integer = picGraph.ClientSize.Height
        Dim bm As New Bitmap(wid, hgt)
        Dim gr As Graphics = Graphics.FromImage(bm)

        ' Draw guide lines.
        gr.Clear(Color.Blue)
        For i As Integer = m_Ymid To picGraph.ClientSize.Height Step GRID_STEP
            gr.DrawLine(Pens.LightBlue, 0, i, wid - 1, i)
        Next i
        For i As Integer = m_Ymid To 0 Step -GRID_STEP
            gr.DrawLine(Pens.LightBlue, 0, i, wid - 1, i)
        Next i

        picGraph.Image = bm
    End Sub

    ' Start drawing the graph.
    Private Sub btnGraph_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGraph.Click
        btnGraph.Text = "Stop"
        btnGraph.Refresh()

        DrawGraph()

        btnGraph.Text = "Start"
    End Sub

    ' Draw a graph for 5 seconds.
    Private Sub DrawGraph()
        ' Generate pseudo-random values.
        Dim y As Integer = m_Y
        Dim stop_time As Date = Now.AddSeconds(5)
        Do While Now < stop_time
            ' Generate the next value.
            NewValue()

            ' Plot the new value.
            PlotValue(y, m_Y)
            y = m_Y
        Loop
    End Sub

    ' Generate the next value.
    Private Sub NewValue()
        ' Delay a bit before calculating the value.
        Dim stop_time As Date = Now.AddMilliseconds(20)
        Do While Now < stop_time
        Loop

        ' Calculate the next value.
        Static rnd As New Random
        m_Y += rnd.Next(-4, 5)
        If m_Y < 0 Then m_Y = 0
        If m_Y >= picGraph.ClientSize.Height - 1 Then m_Y = picGraph.ClientSize.Height - 1
    End Sub

    ' Plot a new value.
    Private Sub PlotValue(ByVal old_y As Integer, ByVal new_y As Integer)
        ' Make the Bitmap and Graphics objects.
        Dim wid As Integer = picGraph.ClientSize.Width
        Dim hgt As Integer = picGraph.ClientSize.Height
        Dim bm As New Bitmap(wid, hgt)
        Dim gr As Graphics = Graphics.FromImage(bm)

        ' Move the old data one pixel to the left.
        gr.DrawImage(picGraph.Image, -1, 0)

        ' Erase the right edge and draw guide lines.
        gr.DrawLine(Pens.Blue, wid - 1, 0, wid - 1, hgt - 1)
        For i As Integer = m_Ymid To picGraph.ClientSize.Height Step GRID_STEP
            gr.DrawLine(Pens.LightBlue, wid - 2, i, wid - 1, i)
        Next i
        For i As Integer = m_Ymid To 0 Step -GRID_STEP
            gr.DrawLine(Pens.LightBlue, wid - 2, i, wid - 1, i)
        Next i

        ' Plot a new pixel.
        gr.DrawLine(Pens.White, wid - 2, old_y, wid - 1, new_y)

        ' Display the result.
        picGraph.Image = bm
        picGraph.Refresh()

        gr.Dispose()
    End Sub

    ' Display the current time.
    Private Sub tmrUpdateClock_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrUpdateClock.Tick
        lblTime.Text = Now.ToString("T")
    End Sub
End Class
